/* msg.h -- declaration for verbosity sensitive feedback function
   Copyright (c) 1988, 89, 90, 91, 92, 93 Miguel Santana
   Copyright (c) 1995, 96, 97 Akim Demaille, Miguel Santana

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* 
 * Note:
 * very strong inspiration was taken in error.[ch] by
 * David MacKenzie <djm@gnu.ai.mit.edu>
 */

/* Get prototypes for the functions defined here.  */
#include "msg.h"

/* The bigger, the more verbose.  Should be set by application */
unsigned int message_verbosity = 0;
/* Where is dump the messages */
FILE * message_stream = stderr;

/* Print the message MESSAGE, which is a printf-style
   format string with optional args if msg_level is bigger than 
   message_verbosity.*/
/* VARARGS */

void
#if defined(VA_START) && __STDC__
message (int msg_level, const char *msg, ...)
#else
message (msg_level, msg, va_alist)
     int msg_level;
     char *msg;
     va_dcl
#endif
{
#ifdef VA_START
  va_list args;
#endif
  
  if (!message_test (msg_level))
    return;
  
#ifdef VA_START
  VA_START (args, msg);
  
  fflush (stdout);
# if HAVE_VPRINTF || _LIBC
  vfprintf (message_stream, msg, args);
# else
  _doprnt (msg, args, message_stream);
# endif
  va_end (args);
#else
  fprintf (message_stream, msg, a1, a2, a3, a4, a5, a6, a7, a8);
#endif
  
  fflush (message_stream);
}
